import { Action, StateValue, IStateNodeConfig, IHistory } from './types';
import State from './State';
export declare class StateNode {
    key: string;
    id: string;
    initial?: string;
    parallel?: boolean;
    history: IHistory;
    states?: Record<string, StateNode>;
    on?: Record<string, string>;
    parent?: StateNode;
    private _events?;
    private _relativeValue;
    private _initialState;
    constructor(config: IStateNodeConfig, history?: IHistory);
    transition(state?: StateValue | State, action?: Action): State;
    next(action?: Action, history?: IHistory): StateValue | undefined;
    getInitialState(): StateValue | undefined;
    getState(relativeStateId: string): StateNode | undefined;
    readonly events: string[];
    getRelativeValue(toNode?: StateNode): StateValue;
}
declare const _default: {
    StateNode: typeof StateNode;
    Machine: (config: IStateNodeConfig) => StateNode;
    State: typeof State;
    matchesState: (parentStateId: StateValue, childStateId: StateValue) => boolean;
    mapState: (stateMap: {
        [stateId: string]: any;
    }, stateId: string) => any;
};
export default _default;
